<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::entropy_encoder_model_kernel_5&lt; alphabet_size, entropy_encoder, total_nodes, order &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html">entropy_encoder_model_kernel_5</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pri-types">Private Types</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1entropy__encoder__model__kernel__5-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::entropy_encoder_model_kernel_5&lt; alphabet_size, entropy_encoder, total_nodes, order &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structdlib_1_1entropy__encoder__model__kernel__5_1_1nodes.html">nodes</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a38dc2ddc88f99adeff220649d12bf5be"><td class="memItemLeft" align="right" valign="top"><a id="a38dc2ddc88f99adeff220649d12bf5be"></a>
typedef <a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a>&#160;</td><td class="memItemRight" valign="bottom"><b>entropy_encoder_type</b></td></tr>
<tr class="separator:a38dc2ddc88f99adeff220649d12bf5be"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:adfdf24cb687d48a56a28e61f5c0071f6"><td class="memItemLeft" align="right" valign="top"><a id="adfdf24cb687d48a56a28e61f5c0071f6"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>entropy_encoder_model_kernel_5</b> (<a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a> &amp;coder)</td></tr>
<tr class="separator:adfdf24cb687d48a56a28e61f5c0071f6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7997ebf7a81e172f8ff7dc206abe9bd"><td class="memItemLeft" align="right" valign="top"><a id="af7997ebf7a81e172f8ff7dc206abe9bd"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:af7997ebf7a81e172f8ff7dc206abe9bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a913558ea835b35e9437d71c9787c3a9c"><td class="memItemLeft" align="right" valign="top"><a id="a913558ea835b35e9437d71c9787c3a9c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>encode</b> (unsigned long symbol)</td></tr>
<tr class="separator:a913558ea835b35e9437d71c9787c3a9c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afc941ee9022f6dc5502feee174a27aec"><td class="memItemLeft" align="right" valign="top"><a id="afc941ee9022f6dc5502feee174a27aec"></a>
<a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>get_entropy_encoder</b> ()</td></tr>
<tr class="separator:afc941ee9022f6dc5502feee174a27aec"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:afa3b44981a4d4c61ddd0d29a38702c7f"><td class="memItemLeft" align="right" valign="top"><a id="afa3b44981a4d4c61ddd0d29a38702c7f"></a>
static unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>get_alphabet_size</b> ()</td></tr>
<tr class="separator:afa3b44981a4d4c61ddd0d29a38702c7f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-types"></a>
Private Types</h2></td></tr>
<tr class="memitem:aa91b536528bf59317a1bf972154e7fe4"><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structdlib_1_1eemk5_1_1node.html">eemk5::node</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#aa91b536528bf59317a1bf972154e7fe4">node</a></td></tr>
<tr class="separator:aa91b536528bf59317a1bf972154e7fe4"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:ad216d9090a213d74981f7009ca07df0f"><td class="memItemLeft" align="right" valign="top"><a id="ad216d9090a213d74981f7009ca07df0f"></a>
<a class="el" href="structdlib_1_1eemk5_1_1node.html">eemk5::node</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>allocate_node</b> ()</td></tr>
<tr class="separator:ad216d9090a213d74981f7009ca07df0f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae6d51fa3d052da104524a3fe85f84d4d"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#ae6d51fa3d052da104524a3fe85f84d4d">space_left</a> () const</td></tr>
<tr class="separator:ae6d51fa3d052da104524a3fe85f84d4d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a57a6c94adc91acdebea4616e88b7a678"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#a57a6c94adc91acdebea4616e88b7a678">exclude</a> (unsigned short symbol)</td></tr>
<tr class="separator:a57a6c94adc91acdebea4616e88b7a678"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5054f21f78b1d6a259d3eee102ff9711"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#a5054f21f78b1d6a259d3eee102ff9711">something_is_excluded</a> ()</td></tr>
<tr class="separator:a5054f21f78b1d6a259d3eee102ff9711"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6bab1be6bd9832a92a121296fa33839b"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#a6bab1be6bd9832a92a121296fa33839b">is_excluded</a> (unsigned short symbol)</td></tr>
<tr class="separator:a6bab1be6bd9832a92a121296fa33839b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0de0363dee6deb8a282e3521f45cad05"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#a0de0363dee6deb8a282e3521f45cad05">clear_exclusions</a> ()</td></tr>
<tr class="separator:a0de0363dee6deb8a282e3521f45cad05"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1ff788684bd8ad69ce2dacfdb32f1aee"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#a1ff788684bd8ad69ce2dacfdb32f1aee">scale_counts</a> (<a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#aa91b536528bf59317a1bf972154e7fe4">node</a> *n)</td></tr>
<tr class="separator:a1ff788684bd8ad69ce2dacfdb32f1aee"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4a23d9954dc786e4fd4dfc2089e8e134"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#a4a23d9954dc786e4fd4dfc2089e8e134">push</a> (<a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#aa91b536528bf59317a1bf972154e7fe4">node</a> *n, <a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#aa91b536528bf59317a1bf972154e7fe4">node</a> *nc)</td></tr>
<tr class="separator:a4a23d9954dc786e4fd4dfc2089e8e134"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6cb6e127e7496b3e04ed8dda77827d02"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#a6cb6e127e7496b3e04ed8dda77827d02">pop</a> (<a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#aa91b536528bf59317a1bf972154e7fe4">node</a> *&amp;n, <a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#aa91b536528bf59317a1bf972154e7fe4">node</a> *&amp;nc)</td></tr>
<tr class="separator:a6cb6e127e7496b3e04ed8dda77827d02"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7a1ffa7922866525621c3655bd840b88"><td class="memItemLeft" align="right" valign="top"><a id="a7a1ffa7922866525621c3655bd840b88"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>entropy_encoder_model_kernel_5</b> (<a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html">entropy_encoder_model_kernel_5</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a>, total_nodes, order &gt; &amp;)</td></tr>
<tr class="separator:a7a1ffa7922866525621c3655bd840b88"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad361b55c4274eb9323544ec4dab1c17b"><td class="memItemLeft" align="right" valign="top"><a id="ad361b55c4274eb9323544ec4dab1c17b"></a>
<a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html">entropy_encoder_model_kernel_5</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a>, total_nodes, order &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html">entropy_encoder_model_kernel_5</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a>, total_nodes, order &gt; &amp;)</td></tr>
<tr class="separator:ad361b55c4274eb9323544ec4dab1c17b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:ae56a03867bf5b15c7f6ef88342dfb19a"><td class="memItemLeft" align="right" valign="top"><a id="ae56a03867bf5b15c7f6ef88342dfb19a"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>next_node</b></td></tr>
<tr class="separator:ae56a03867bf5b15c7f6ef88342dfb19a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a05aca3dec9190b8ab9e36f3d7483b634"><td class="memItemLeft" align="right" valign="top"><a id="a05aca3dec9190b8ab9e36f3d7483b634"></a>
<a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>coder</b></td></tr>
<tr class="separator:a05aca3dec9190b8ab9e36f3d7483b634"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6a56d28704eb95f22a599f984dfe2e2f"><td class="memItemLeft" align="right" valign="top"><a id="a6a56d28704eb95f22a599f984dfe2e2f"></a>
<a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#aa91b536528bf59317a1bf972154e7fe4">node</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>root</b></td></tr>
<tr class="separator:a6a56d28704eb95f22a599f984dfe2e2f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0c6465950d872ae05a739b5b227453ac"><td class="memItemLeft" align="right" valign="top"><a id="a0c6465950d872ae05a739b5b227453ac"></a>
<a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#aa91b536528bf59317a1bf972154e7fe4">node</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>cur</b></td></tr>
<tr class="separator:a0c6465950d872ae05a739b5b227453ac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a651227623b9d767b335a85266c93bf8f"><td class="memItemLeft" align="right" valign="top"><a id="a651227623b9d767b335a85266c93bf8f"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>cur_order</b></td></tr>
<tr class="separator:a651227623b9d767b335a85266c93bf8f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a755353a0f7598eb63fa4f368093a272b"><td class="memItemLeft" align="right" valign="top"><a id="a755353a0f7598eb63fa4f368093a272b"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>exc</b> [alphabet_size/32+1]</td></tr>
<tr class="separator:a755353a0f7598eb63fa4f368093a272b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad37a9b4aadf91a0ac2ee8222df15c59c"><td class="memItemLeft" align="right" valign="top"><a id="ad37a9b4aadf91a0ac2ee8222df15c59c"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>exc_used</b></td></tr>
<tr class="separator:ad37a9b4aadf91a0ac2ee8222df15c59c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac38fcdb1b0aa3cd763b4f531f1de4403"><td class="memItemLeft" align="right" valign="top"><a id="ac38fcdb1b0aa3cd763b4f531f1de4403"></a>
<a class="el" href="structdlib_1_1entropy__encoder__model__kernel__5_1_1nodes.html">nodes</a>&#160;</td><td class="memItemRight" valign="bottom"><b>stack</b> [order+1]</td></tr>
<tr class="separator:ac38fcdb1b0aa3cd763b4f531f1de4403"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae32e68289e8d3b2cc819c2c5072b819c"><td class="memItemLeft" align="right" valign="top"><a id="ae32e68289e8d3b2cc819c2c5072b819c"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>stack_size</b></td></tr>
<tr class="separator:ae32e68289e8d3b2cc819c2c5072b819c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Typedef Documentation</h2>
<a id="aa91b536528bf59317a1bf972154e7fe4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa91b536528bf59317a1bf972154e7fe4">&#9670;&nbsp;</a></span>node</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;unsigned long alphabet_size, typename entropy_encoder, unsigned long total_nodes, unsigned long order&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structdlib_1_1eemk5_1_1node.html">eemk5::node</a> <a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html">dlib::entropy_encoder_model_kernel_5</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a>, total_nodes, order &gt;::<a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#aa91b536528bf59317a1bf972154e7fe4">node</a></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">REQUIREMENTS ON total_nodes
    - 4096 &lt; total_nodes
    - this is the total number of nodes that we will use in the tree

REQUIREMENTS ON order
    - 0 &lt;= order
    - this is the maximum depth-1 the tree will be allowed to go (note 
      that the root level is depth 0).  

GENERAL NOTES
    This implementation follows more or less the implementation 
    strategy laid out by Alistair Moffat in his paper
    Implementing the PPM data compression scheme.  Published in IEEE 
    Transactions on Communications, 38(11):1917-1921, 1990.

    The escape method used will be method D. 

    This also uses Dmitry Shkarin's Information Inheritance scheme.
    (described in "PPM: one step to practicality" and "Improving the 
    Efficiency of the PPM Algorithm")


INITIAL VALUE
    - root == pointer to an array of total_nodes nodes
    - next_node == 1
    - cur == root
    - cur_order = 0
    - root-&gt;next == 0
    - root-&gt;parent_context == 0
    - root-&gt;child_context == 0
    - root-&gt;escapes == 0
    - root-&gt;total == 0
    - stack_size == 0
    - exc_used == false
    - for all i: exc[i] == 0

CONVENTION
    - pop() == stack[stack_size-1].n and stack[stack_size-1].nc
    - exc_used == something_is_excluded()
    - is_excluded(symbol) == bit symbol&amp;0x1F from exc[symbol&gt;&gt;5]
    - &amp;get_entropy_encoder() == coder
    - root == pointer to an array of total_nodes nodes.
      this is also the root of the tree.
    - if (next_node &lt; total_nodes) then
        - next_node == the next node in root that has not yet been allocated                                

    - root-&gt;next == 0
    - root-&gt;parent_context == 0


    - for every node in the tree:
      {
        - NOTATION: 
            - The "context" of a node is the string of symbols seen
              when you go from the root of the tree down (down though
              child context pointers) to the node, including the symbol at 
              the node itself.  (note that the context of the root node 
              is "" or the empty string)
            - A set of nodes is in the same "context set" if all the node's
              contexts are of length n and all the node's contexts share
              the same prefix of length n-1.
            - The "child context set" of a node is a set of nodes with
              contexts that are one symbol longer and prefixed by the node's 
              context.  For example, if a node has a context "abc" then the 
              nodes for contexts "abca", "abcb", "abcc", etc. are all in 
              the child context set of the node.
            - The "parent context" of a node is the context that is one 
              symbol shorter than the node's context and includes the 
              symbol in the node.  So the parent context of a node with 
              context "abcd" would be the context "bcd".


        - if (next != 0) then 
            - next == pointer to the next node in the same context set
        - if (child_context != 0) then
            - child_context == pointer to the first node of the child 
              context set for this node.
            - escapes &gt; 0
        - if (parent_context != 0) then
            - parent_context == pointer to the parent context of this node.
        - else
            - this node is the root node of the tree


        - if (this is not the root node) then
            - symbol == the symbol represented with this node
            - count == the number of times this symbol has been seen in its
              parent context.
        - else
            - the root doesn't have a symbol.  i.e. the context for the
              root node is "" or the empty string.

        - total == The sum of the counts of all the nodes 
          in the child context set + escapes. 
        - escapes == the escape count for the context represented
          by the node.                   
        - count &gt; 0                    
    }


    - cur_order &lt; order
    - cur_order == the depth of the node cur in the tree.
      (note that the root node has depth 0)
    - cur == pointer to the node in the tree who's context matches
      the most recent symbols we have seen.
</pre><p>! </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a0de0363dee6deb8a282e3521f45cad05"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0de0363dee6deb8a282e3521f45cad05">&#9670;&nbsp;</a></span>clear_exclusions()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;unsigned long alphabet_size, typename entropy_encoder , unsigned long total_nodes, unsigned long order&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html">dlib::entropy_encoder_model_kernel_5</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a>, total_nodes, order &gt;::clear_exclusions </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - if (symbol has been excluded) then
        - returns true
    - else
        - returns false
</pre><p> ! </p>

</div>
</div>
<a id="a57a6c94adc91acdebea4616e88b7a678"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a57a6c94adc91acdebea4616e88b7a678">&#9670;&nbsp;</a></span>exclude()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;unsigned long alphabet_size, typename entropy_encoder , unsigned long total_nodes, unsigned long order&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html">dlib::entropy_encoder_model_kernel_5</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a>, total_nodes, order &gt;::exclude </td>
          <td>(</td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>symbol</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns true if there is at least 1 free node left.
    - returns false otherwise
</pre><p> ! </p>

</div>
</div>
<a id="a6bab1be6bd9832a92a121296fa33839b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6bab1be6bd9832a92a121296fa33839b">&#9670;&nbsp;</a></span>is_excluded()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;unsigned long alphabet_size, typename entropy_encoder , unsigned long total_nodes, unsigned long order&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html">dlib::entropy_encoder_model_kernel_5</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a>, total_nodes, order &gt;::is_excluded </td>
          <td>(</td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>symbol</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns true if some symbol has been excluded.
      returns false otherwise
</pre><p> ! </p>

</div>
</div>
<a id="a6cb6e127e7496b3e04ed8dda77827d02"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6cb6e127e7496b3e04ed8dda77827d02">&#9670;&nbsp;</a></span>pop()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;unsigned long alphabet_size, typename entropy_encoder , unsigned long total_nodes, unsigned long order&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html">dlib::entropy_encoder_model_kernel_5</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a>, total_nodes, order &gt;::pop </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#aa91b536528bf59317a1bf972154e7fe4">node</a> *&amp;&#160;</td>
          <td class="paramname"><em>n</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#aa91b536528bf59317a1bf972154e7fe4">node</a> *&amp;&#160;</td>
          <td class="paramname"><em>nc</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - stack_size &lt; order
ensures
    - #pop(a,b): a == n &amp;&amp; b == nc
</pre><p> ! </p>

</div>
</div>
<a id="a4a23d9954dc786e4fd4dfc2089e8e134"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4a23d9954dc786e4fd4dfc2089e8e134">&#9670;&nbsp;</a></span>push()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;unsigned long alphabet_size, typename entropy_encoder , unsigned long total_nodes, unsigned long order&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html">dlib::entropy_encoder_model_kernel_5</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a>, total_nodes, order &gt;::push </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#aa91b536528bf59317a1bf972154e7fe4">node</a> *&#160;</td>
          <td class="paramname"><em>n</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#aa91b536528bf59317a1bf972154e7fe4">node</a> *&#160;</td>
          <td class="paramname"><em>nc</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - divides all the counts in the child context set of n by 2.
    - none of the nodes in the child context set will have a count of 0
</pre><p> ! </p>

</div>
</div>
<a id="a1ff788684bd8ad69ce2dacfdb32f1aee"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1ff788684bd8ad69ce2dacfdb32f1aee">&#9670;&nbsp;</a></span>scale_counts()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;unsigned long alphabet_size, typename entropy_encoder , unsigned long total_nodes, unsigned long order&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html">dlib::entropy_encoder_model_kernel_5</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a>, total_nodes, order &gt;::scale_counts </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html#aa91b536528bf59317a1bf972154e7fe4">node</a> *&#160;</td>
          <td class="paramname"><em>n</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - for all symbols #is_excluded(symbol) == false
    - #something_is_excluded() == true
</pre><p> ! </p>

</div>
</div>
<a id="a5054f21f78b1d6a259d3eee102ff9711"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5054f21f78b1d6a259d3eee102ff9711">&#9670;&nbsp;</a></span>something_is_excluded()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;unsigned long alphabet_size, typename entropy_encoder , unsigned long total_nodes, unsigned long order&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html">dlib::entropy_encoder_model_kernel_5</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a>, total_nodes, order &gt;::something_is_excluded </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - #is_excluded(symbol) == true
    - #something_is_excluded() == true
</pre><p> ! </p>

</div>
</div>
<a id="ae6d51fa3d052da104524a3fe85f84d4d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae6d51fa3d052da104524a3fe85f84d4d">&#9670;&nbsp;</a></span>space_left()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;unsigned long alphabet_size, typename entropy_encoder , unsigned long total_nodes, unsigned long order&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1entropy__encoder__model__kernel__5.html">dlib::entropy_encoder_model_kernel_5</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a>, total_nodes, order &gt;::space_left </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - space_left() == true
ensures
    - returns a pointer to a new node
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="entropy__encoder__model__kernel__5_8h_source.html">entropy_encoder_model_kernel_5.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
